package org.eclipse.e4.languages.javascript.jsdi.rhino.connect;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.e4.languages.javascript.debug.connect.Connection;
import org.eclipse.e4.languages.javascript.debug.connect.DebugSession;
import org.eclipse.e4.languages.javascript.debug.connect.SocketTransportService;
import org.eclipse.e4.languages.javascript.debug.connect.TransportService;
import org.eclipse.e4.languages.javascript.jsdi.VirtualMachine;
import org.eclipse.e4.languages.javascript.jsdi.connect.AttachingConnector;
import org.eclipse.e4.languages.javascript.jsdi.rhino.VirtualMachineImpl;

public class RhinoAttachingConnector implements AttachingConnector {

	public VirtualMachine attach(Map arguments) throws IOException {
		TransportService service = new SocketTransportService();
		HostArgument host = (HostArgument) arguments.get("host");
		PortArgument port = (PortArgument) arguments.get("port");
		Connection c = service.attach(host.value() + ":" + port.value(), 10000, 10000); //$NON-NLS-1$
		DebugSession session = new DebugSession(c);
		return new VirtualMachineImpl(session);
	}

	public Map defaultArguments() {
		Map result = new HashMap();
		result.put("host", new HostArgument("localhost"));
		result.put("port", new PortArgument(9000));
		return result;
	}

	public String description() {
		return "Mozilla Rhino - Attaching Connector";
	}

	public String name() {
		return "Mozilla Rhino - Attaching Connector";
	}
}
